package com.example.carterjacobsen.demogcmdemo;

import android.content.Context;
import android.os.AsyncTask;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.Toast;

import com.example.demo_gcm_demo.backend.registration.Registration;
import com.google.android.gms.gcm.GoogleCloudMessaging;
import com.google.api.client.extensions.android.http.AndroidHttp;
import com.google.api.client.extensions.android.json.AndroidJsonFactory;
import com.google.api.client.googleapis.services.AbstractGoogleClientRequest;
import com.google.api.client.googleapis.services.GoogleClientRequestInitializer;

import java.io.IOException;
import java.util.HashMap;
import java.util.Map;
import java.util.logging.Level;
import java.util.logging.Logger;

public class MainActivity extends AppCompatActivity implements Button.OnClickListener{
    //    public static String SERVER_ADDR = "https://abstract-arc-123122.appspot.com";
    public static String SERVER_ADDR = "http://127.0.0.1:8088";
    private Button postButton;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        postButton = (Button)findViewById(R.id.button);
        postButton.setOnClickListener(this);
        new GcmRegistrationAsyncTask(this).execute();

    }

    @Override
    public void onClick(View view){
        new UploadDataAsyncTask().execute();
    }

    class UploadDataAsyncTask extends AsyncTask<Void, Void, String>{
        @Override
        // Get history and upload it to the server.
        protected String doInBackground(Void... arg0) {
            // Upload the history of all entries using upload().
            String uploadState="";
            try {
                //XD: A Map is a data structure consisting of a set of keys and values in which each key is mapped to a single value.
                Map<String, String> params = new HashMap<String, String>();
                params.put("name", "XD");
                params.put("addr", "Sudikoff 211");
                params.put("phone", "123456789");
                ServerUtilities.post(SERVER_ADDR+"/add.do", params);
            } catch (IOException e1) {
                uploadState = "Sync failed: " + e1.getCause();
                Log.e("TAGG", "data posting error " + e1);
            }

            return uploadState;
        }

        @Override
        protected void onPostExecute(String errString) {
            String resultString;
            if(errString.equals(""))
                resultString =  " entry uploaded.";
            else
                resultString = errString;
            Toast.makeText(getApplicationContext(), resultString, Toast.LENGTH_SHORT).show();
        }
    }

    class GcmRegistrationAsyncTask extends AsyncTask<Void, Void, String> {
        private Registration regService = null;
        private GoogleCloudMessaging gcm;
        private Context context;

        // TODO: change to your own sender ID to Google Developers Console project number, as per instructions above
        private static final String SENDER_ID = "39250181856";

        public GcmRegistrationAsyncTask(Context context) {
            this.context = context;
        }

        @Override
        protected String doInBackground(Void... params) {
            if (regService == null) {
                //XD: this builder block is for debugging on localhost (e.g. http://127.0.0.1:8088)
                Registration.Builder builder = new Registration.Builder(AndroidHttp.newCompatibleTransport(),
                        new AndroidJsonFactory(), null)
                        // Need setRootUrl and setGoogleClientRequestInitializer only for local testing,
                        // otherwise they can be skipped
                        .setRootUrl(SERVER_ADDR+"/_ah/api/")
                        .setGoogleClientRequestInitializer(new GoogleClientRequestInitializer() {
                            @Override
                            public void initialize(AbstractGoogleClientRequest<?> abstractGoogleClientRequest)
                                    throws IOException {
                                abstractGoogleClientRequest.setDisableGZipContent(true);
                            }
                        });
                // end of optional local run code

                //XD: newCompatibleTransport - returns a new thread-safe HTTP transport instance that is compatible with Android SDKs prior to * Gingerbread.
                //XD: use this builder instead if you deploy your backend to the cloud (e.g. https://abstract-arc-123122.appspot.com)
//                Registration.Builder builder = new Registration.Builder(AndroidHttp.newCompatibleTransport(), new AndroidJsonFactory(), null)
//                        .setRootUrl(SERVER_ADDR +"/_ah/api/");
                regService = builder.build();
            }

            String msg = "";
            try {
                if (gcm == null) {
                    gcm = GoogleCloudMessaging.getInstance(context);
                }
                String regId = gcm.register(SENDER_ID);
                msg = "Device registered, registration ID=" + regId;

                // You should send the registration ID to your server over HTTP,
                // so it can use GCM/HTTP or CCS to send messages to your app.
                // The request to your server should be authenticated if your app
                // is using accounts.
                regService.register(regId).execute();
                Log.d("XD", "regId: " + regId);

            } catch (IOException ex) {
                ex.printStackTrace();
                msg = "Error: " + ex.getMessage();
                Log.d("XD", msg);

            }
            return msg;
        }

        @Override
        protected void onPostExecute(String msg) {
            Toast.makeText(context, msg, Toast.LENGTH_LONG).show();
            Logger.getLogger("REGISTRATION").log(Level.INFO, msg);
        }
    }
}
